Version:        0.4.0
%global githubuser wlanslovenija
%global forgeurl https://github.com/%{githubuser}/tunneldigger

%forgemeta

Name:           tunneldigger
Release:        2%{?dist}
Summary:        L2TP VPN client

License:        AGPLv3
URL:            %{forgeurl}
Source0:        %{forgesource}

# Client
Source100:      %{name}.service
Source101:      %{name}@.service
Source102:      %{name}-client.conf
# Broker
Source200:      %{name}-broker.service
Source201:      %{name}-broker@.service
Source202:      %{name}-modules.conf
Source203:      %{name}-logrotate.conf

#Client
BuildRequires:  gcc
BuildRequires:  cmake
BuildRequires:  libasyncns-devel
BuildRequires:  libnl3-devel

# Broker
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  systemd

Requires:  kmod(l2tp_core.ko)
Requires:  kmod(l2tp_eth.ko)
Requires:  kmod(l2tp_netlink.ko)
# Workaround for dnf pulling in kernel-debug-modules-extra over
# kernel-modules-extra to satisfy the kmod dependencies (rhbz#1192189)
Suggests:       kernel-modules-extra

%description
Tunneldigger is one of the projects of wlan slovenija open wireless network. It
is a simple VPN tunneling solution based on L2TPv3 tunnels supported in recent
Linux kernels.

This package contains the client used to connect to a tunneldigger broker.


%package   broker
Summary:   L2TP VPN broker
Requires:  kmod(l2tp_core.ko)
Requires:  kmod(l2tp_eth.ko)
Requires:  kmod(l2tp_netlink.ko)
Obsoletes: %{name} < 0.3.0-2

BuildArch: noarch

%description    broker 
Tunneldigger is one of the projects of wlan slovenija open wireless network. It
is a simple VPN tunneling solution based on L2TPv3 tunnels supported in recent
Linux kernels.

This package contains the broker.


%prep
%forgeautosetup


%build
pushd client
%cmake
%cmake_build
popd

pushd broker
%py3_build
popd


%install
rm -rf $RPM_BUILD_ROOT

# Client installation
pushd client
%cmake_install
popd

# Broker install
pushd broker
%py3_install
install -Dpm 0644 l2tp_broker.cfg.example $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/broker/%{name}.conf
popd

install -dm 0755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}

install -Dpm 0644 %{S:100} $RPM_BUILD_ROOT%{_unitdir}/%{name}.service
install -Dpm 0644 %{S:101} $RPM_BUILD_ROOT%{_unitdir}/%{name}@.service
install -Dpm 0644 %{S:102} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/client/%{name}.conf

install -Dpm 0644 %{S:200} $RPM_BUILD_ROOT%{_unitdir}/%{name}-broker.service
install -Dpm 0644 %{S:201} $RPM_BUILD_ROOT%{_unitdir}/%{name}-broker@.service
install -Dpm 0644 %{S:202} $RPM_BUILD_ROOT%{_sysconfdir}/modules-load.d/%{name}-broker.conf
install -Dpm 0644 %{S:203} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}-broker


%files
%license COPYING LICENSE
%doc docs HISTORY.rst README.rst
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}@.service
%config(noreplace) %{_sysconfdir}/%{name}/client/%{name}.conf


%files broker
%license COPYING LICENSE
%doc docs HISTORY.rst README.rst
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/broker/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}-broker
# needed modules might change, no need to keep users' settings
# hence the missing (noreplace) after %%config
%config %{_sysconfdir}/modules-load.d/%{name}-broker.conf
%attr(0755,root,root) %dir %{_localstatedir}/log/%{name}
%{python3_sitelib}/%{name}_broker
%{python3_sitelib}/%{name}_broker-%{version}*.egg-info
%{_unitdir}/%{name}-broker.service
%{_unitdir}/%{name}-broker@.service


%changelog
* Mon Apr 14 2025 Felix Kaechele <felix@kaechele.ca> - 0.4.0-2
- rebuild

* Wed Feb 07 2024 Felix Kaechele <felix@kaechele.ca> - 0.4.0-1
- update to 0.4.0

* Wed Nov 03 2021 Felix Kaechele <felix@kaechele.ca> - 0.4.0-0.7.git4f72b30
- update to latest git commit

* Thu Oct 29 2020 Felix Kaechele <felix@kaechele.ca> - 0.4.0-0.6.git56edb33
- update to latest git commit

* Thu Aug 13 2020 Felix Kaechele <felix@kaechele.ca> - 0.4.0-0.5.gitb8fd97e
- update to latest git commit
- fixes high load issue
- use %%cmake macros

* Fri Apr 03 2020 Felix Kaechele <heffer@fedoraproject.org> - 0.4.0-0.4.git1dc95fb
- test build

* Mon Nov 04 2019 Felix Kaechele <heffer@fedoraproject.org> - 0.4.0-0.3.gitb20ba68
- latest IPv6 test build

* Wed Oct 16 2019 Felix Kaechele <heffer@fedoraproject.org> - 0.4.0-0.2.git63182ff
- IPv6 test build

* Sun Oct 13 2019 Felix Kaechele <heffer@fedoraproject.org> - 0.4.0-0.1.git0a2fca1
- Python 3 and No NAT test build

* Mon Sep 30 2019 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-5.1.git1fb69bf
- Python 3 test build

* Thu Nov 01 2018 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-5.git18f365f
- update to latest git release

* Sun Jan 14 2018 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-4.gitd7db350
- add instanced client unit files
- moved client config to /etc/tunneldigger/client
- moved broker config to /etc/tunneldigger/broker

* Fri Dec 29 2017 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-3.gitd7db350
- update to latest git version
- fix systemd units

* Thu Nov 23 2017 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-2.git20e52a5
- update to latest git version
- fixes duplicate tunnel id issue
- build client
- rename broker package to -broker

* Tue Apr 25 2017 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-1
- use final version

* Sun Apr 02 2017 Felix Kaechele <heffer@fedoraproject.org> - 0.3.0-0.1.git235e111
- initial package

